from .common import *
from .DebInfo import *
from .DependCheck import *
import platform

class Check:
    def __init__(self,level, deb, fsold):
        """
        整个模块入口初始化函数
        :param deb: 检测的包名
        :param fsold: chroot路径
        """
        self.deb = deb
        self.path="./"
        self.fsold = fsold

        self.deb_info = {
            "pkg_name": "未获取",
            "pkg_size": "未获取",
            "exec_num": "未获取",
            "service_num": "未获取",
            "pkg-version": "未获取",
            "depend_num": "未获取",
            "so_num": "未获取",
            "conf_num": "未获取",
            "pkg_arch": "未获取",
            "inst_exec": "未获取",
            "shell_num": "未获取",
            "multi_num": "未获取",
            "pkg_sign": "未获取",
            "uninst_exec": "未获取",
            "desktop_num": "未获取",
            "icon_num": "未获取",
        }
        self.deb_index = {
            "conf": [],
            "script": [],
            "exec": [],
            "desktop": [],
            "so": [],
            "service": [],
            "multi": [],
            "icon": []
        }  # 安装包目录
        arch=platform.machine()
        if arch == "x86_64":
            self.arch = "amd64"
        elif arch == "aarch64":
            self.arch = "arm64"
        else :
            self.arch = arch


    depend_list = []
    file_list = []
    so_info = {}
    dep_info = {}
    __err_dep = []

    def get_deb_info(self):
        print("开始获取应用包信息")
        deb_info = DebInfo(self.deb)
        self.deb_info.update(deb_info.get_control_info())
        self.deb_index.update(deb_info.file_type())

        # self.log.debug(self.deb_info["pkg_arch"])
        self.depend_list = deb_info.depend_list

        print("获取应用包信息完成")

    def depend_is_exist(self):
        print("开始进行依赖库存在状态检测")

        ddc = DebDependCheck(self.depend_list ,self.arch)
        cdc_res = ddc.check()


        elfs = []
        elfs.extend(self.deb_index["exec"])
        elfs.extend(self.deb_index["so"])

        edc = ElfDependCheck(elfs,self.arch)
        edc.un_check_deb = [self.deb_info["pkg_name"]]
        # edc.un_check_deb.extend(list(cdc_res.keys()))
        edc.un_check_so = [so.split("/")[-1] for so in self.deb_index["so"]]
        edc.check()
        edc_res = edc.check_res

        in_cdc = set(cdc_res)
        in_edc = set(edc_res)

        add_res = in_edc - in_cdc

        result = cdc_res + list(add_res)

        if os.path.exists("/kpct.list"):

            listfile = open("/kpct.list", "r", encoding='utf-8')
            file = []
            line = listfile.readline().replace('\r', '').replace('\n', '')  # 读取第一行
            while line:
                file.append(line)  # 列表增加
                line = listfile.readline().replace('\r', '').replace('\n', '')  # 读取下一行

            listfile.close()

            old_res = set(file)
            new_res = set(result)
            add_res = new_res-old_res
            result = file + list(add_res)




        f = open("/kpct.list", "w")

        for line in result:
            f.write(line + '\n')
        f.close()

        # self.so_info = edc.so_info
        # self.dep_info = edc.deb_info




        print("依赖库存在状态检测已完成")