#!/usr/bin/python3
#TODO: more cfg file
#TODO: wrapping about section/key 

from configparser import ConfigParser
import logging
import os
import threading

__all__ = ["RMConf"]

lock = threading.Lock()

class RMConf():
    def __init__(self,path) -> None:
        self.SEC_PERIOD     = 'period'
        self.KEY_BACKPERIOD = 'backperiod'
        self.SEC_LOG        = 'logging'
        self.KEY_LOGLEVEL   = 'loglevel'
        self.SEC_SWITCH     = 'switch'
        self.KEY_SW_ETC     = 'moveetc'
        self.KEY_SW_APP     = 'moveapp'
        self.KEY_SW_SEC     = 'movesecutiry'
        self.KEY_SW_CLEAR   = 'clearoldfs'
        self.KEY_SW_BT      = "usebt"
        self.path = path
        if not os.path.exists(path):
            # 创建文件
            try:
                Fd = os.open(path, os.O_CREAT|os.O_RDWR)
                os.close(Fd)
            except Exception as e:
                logging.error("[Conf]: create file failed[%s].", e)

    # TODO:怀疑多线程调用，引起错误
    # 覆盖原key value
    def change_key_value(self, sec, key, value=None):
        if value == None:
            logging.error("[Conf]: There is no value of sec[%s] key[%s]", sec, key)
            return 0
        if "[" in value:
            logging.error("[Conf]: There is err value[%s] of sec[%s] key[%s]", value, sec, key)
            return 0            
        lock.acquire()
        try:
            conf = ConfigParser()
            conf.read(self.path, encoding="utf-8")
            if not conf.has_section(sec):
                conf.add_section(sec)
            conf.set(sec, key, value)
            conf.write(open(self.path, "w+", encoding="utf-8"))
            logging.info("[Conf]: change sec[%s] key[%s] value[%s]", sec, key, value)
        except Exception as e:
            logging.error("[Conf]: change sec[%s] key[%s] value[%s] err[%s]", sec, key, value, e)
        lock.release()

    def get_key(self, sec, key):
        value = None
        try:
            conf = ConfigParser()
            conf.read(self.path, encoding="utf-8")
            if not conf.has_section(sec):
                logging.info("[Conf]: There is not sec[%s].", sec)
                return None
            if not conf.has_option(sec, key):
                logging.info("[Conf]: There is not key[%s] in sec[%s].", key, sec)
                return None

            value = conf.get(sec, key)
            logging.info("[Conf]: Get sec[%s] key[%s] value[%s]", sec, key, value)
            if value.startswith("['") or value.startswith("[\""):
                value = value.split("'")[1]
                logging.warning("[Conf]: GetEX sec[%s] key[%s] value[%s]", sec, key, value)
        except Exception as e:
            logging.error("[Conf]: get sec[%s] key[%s] err[%s]", sec, key, e)

        return value
    
# 对 /etc/RevisionsManager/RevisionsManager.conf 文件的管理
class RMBaseConf():
    pass


# 对 /etc/RevisionsManager/RevisionsManager.state 文件的管理
class RMStateConf():
    pass




if __name__ == "__main__":
    path = "/etc/RevisionsManager/RevisionsManager.conf"
    rmConf = RMConf(path)
    pass
